﻿using System;
using System.Drawing;
using Infragistics;
using System.Collections.Generic;

using MonoTouch.Foundation;
using MonoTouch.UIKit;

namespace IGRadialLineChartAxisLabelsIssue
{

	public class MyObject  : NSObject
	{
		[Export("mystring")]
		public NSString myString {get;set;}
		[Export("num1")]
		public double myNum1 {get;set;}
		[Export("num2")]
		public double myNum2 {get;set;}
	}


	public partial class IGRadialLineChartAxisLabelsIssueViewController : UIViewController
	{
		static bool UserInterfaceIdiomIsPhone {
			get { return UIDevice.CurrentDevice.UserInterfaceIdiom == UIUserInterfaceIdiom.Phone; }
		}

		public IGRadialLineChartAxisLabelsIssueViewController (IntPtr handle) : base (handle)
		{
		}

		public override void DidReceiveMemoryWarning ()
		{
			// Releases the view if it doesn't have a superview.
			base.DidReceiveMemoryWarning ();
			
			// Release any cached data, images, etc that aren't in use.
		}

		public List<NSObject> GenerateData(List <NSObject> data)
		{
			Random r = new Random();

			MyObject a = new MyObject ();
			a.myString = new NSString( "Jan");
			a.myNum1 = r.Next () % 10;
			a.myNum2 = r.Next () % 10;
			data.Add (a);

			a = new MyObject ();
			a.myString =new NSString( "Feb");
			a.myNum1 =r.Next () % 10;
			a.myNum2 = r.Next () % 10;
			data.Add (a);


			a = new MyObject ();
			a.myString =new NSString( "Mar");
			a.myNum1 = r.Next () % 10;
			a.myNum2 = r.Next () % 10;
			data.Add (a);

			a = new MyObject ();
			a.myString = new NSString("Apr");
			a.myNum1 = r.Next () % 10;
			a.myNum2 = r.Next () % 10;
			data.Add (a);

			return data;
		}

		IGCategorySeriesDataSourceHelper source;
		IGCategorySeriesDataSourceHelper source2;
		List<NSObject> data;
		#region View lifecycle

		public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();
			
			data = new List<NSObject> ();

			data = GenerateData (data);

			source = new IGCategorySeriesDataSourceHelper (data.ToArray (), "num1");

			source.LabelPath = "mystring";

			source2 = new IGCategorySeriesDataSourceHelper (data.ToArray (), "num2");

			source2.LabelPath = "mystring";

			IGChartView chart = new IGChartView (this.View.Frame);
			chart.AutoresizingMask = UIViewAutoresizing.FlexibleHeight | UIViewAutoresizing.FlexibleWidth;
			this.View.AddSubview (chart);

			IGCategoryAngleAxis angleAxis = new IGCategoryAngleAxis ("angleAxis");
			IGNumericRadiusAxis radiusAxis = new IGNumericRadiusAxis ("radiusAxis");

			radiusAxis.Minimum = 0;
			radiusAxis.Maximum = 10;

			chart.AddAxis (angleAxis);
			chart.AddAxis (radiusAxis);
			radiusAxis.InnerRadiusExtentScale = 0.10f;
			radiusAxis.LabelsLocation = IGAxisLabelsLocation.IGAxisLabelsLocationInsideRight;

			IGRadialLineSeries series = new IGRadialLineSeries ("firstSeries");

			series.AngleAxis = angleAxis;
			series.ValueAxis = radiusAxis;
			series.DataSource = source;
			chart.AddSeries (series);

			IGRadialLineSeries series2 = new IGRadialLineSeries ("secondSeries");

			series2.AngleAxis = angleAxis;
			series2.ValueAxis = radiusAxis;
			series2.DataSource = source2;
			chart.AddSeries (series2);
		}

		public override void ViewWillAppear (bool animated)
		{
			base.ViewWillAppear (animated);
		}

		public override void ViewDidAppear (bool animated)
		{
			base.ViewDidAppear (animated);
		}

		public override void ViewWillDisappear (bool animated)
		{
			base.ViewWillDisappear (animated);
		}

		public override void ViewDidDisappear (bool animated)
		{
			base.ViewDidDisappear (animated);
		}

		#endregion
	}
}

